----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:27:08 10/17/2010 
-- Design Name: 
-- Module Name:    op2p_host_wb_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity op2p_host_wb_if is
    Port ( 
			  --instruction registers : this IP is slave on this
			  aurora_config_wb_data_o : in std_logic_vector(31 downto 0); 
			  aurora_config_wb_data_i : out std_logic_vector(31 downto 0);
			  aurora_config_wb_addr_i : in std_logic_vector(4 downto 0);
			  aurora_config_wb_cyc_i : in std_logic;
			  aurora_config_wb_stb_i : in std_logic;
			  aurora_config_wb_wr_i : in std_logic;
			  aurora_config_wb_ack_o : out std_logic;
			  aurora_config_wb_clk_i : in std_logic; 	
			  aurora_config_wb_sel_o :  in std_logic_vector(3 downto 0);
			  --system signals			  
			  aurora_reset : in std_logic;
			  x25m_clk : in std_logic;
			  user_clk_i : in std_logic;
			  --interrupt out:	
			  aurora_irq : out  STD_LOGIC;
			  --signals to the aurora/op2p scheduler:
			aurora_wr_sourceaddress_regrd_en : in  std_logic; 
			aurora_wr_sourceaddress_regdout : out std_logic_vector(31 downto 0); 
			aurora_wr_sourceaddress_regempty : out std_logic; 
			aurora_wr_targetaddress_regrd_en : in  std_logic; 
			aurora_wr_targetaddress_regdout : out std_logic_vector(31 downto 0); 
			aurora_wr_targetaddress_regempty : out std_logic; 
			aurora_wr_sourceid_regrd_en : in  std_logic; 
			aurora_wr_sourceid_regdout : out std_logic_vector(31 downto 0); 
			aurora_wr_sourceid_regempty : out std_logic; 
			aurora_wr_targetid_regrd_en : in  std_logic; 
			aurora_wr_targetid_regdout : out std_logic_vector(31 downto 0); 
			aurora_wr_targetid_regempty : out std_logic; 
			aurora_wr_bytecount_regrd_en : in  std_logic; 
			aurora_wr_bytecount_regdout : out std_logic_vector(31 downto 0); 
			aurora_wr_bytecount_regempty : out std_logic; 
			aurora_rdreq_localaddress_regrd_en : in  std_logic; 
			aurora_rdreq_localaddress_regdout : out std_logic_vector(31 downto 0); 
			aurora_rdreq_localaddress_regempty : out std_logic; 
			aurora_rdreq_targetaddress_regrd_en : in  std_logic; 
			aurora_rdreq_targetaddress_regdout : out std_logic_vector(31 downto 0); 
			aurora_rdreq_targetaddress_regempty : out std_logic; 
			aurora_rdreq_localid_regrd_en : in  std_logic; 
			aurora_rdreq_localid_regdout : out std_logic_vector(31 downto 0); 
			aurora_rdreq_localid_regempty : out std_logic; 
			aurora_rdreq_targetid_regrd_en : in  std_logic; 
			aurora_rdreq_targetid_regdout : out std_logic_vector(31 downto 0); 
			aurora_rdreq_targetid_regempty : out std_logic; 
			aurora_rdreq_bytecount_regrd_en : in  std_logic; 
			aurora_rdreq_bytecount_regdout : out std_logic_vector(31 downto 0); 
			aurora_rdreq_bytecount_regempty : out std_logic; 
			aurora_forw_freeupaddr_regrd_en : in  std_logic; 
			aurora_forw_freeupaddr_regdout : out std_logic_vector(31 downto 0); 
			aurora_forw_freeupaddr_regempty : out std_logic; 
			aurora_forw_freeupsize_regrd_en : in  std_logic; 
			aurora_forw_freeupsize_regdout : out std_logic_vector(31 downto 0); 
			aurora_forw_freeupsize_regempty : out std_logic; 
			 --these have to be doubleflopped to the userclk clock domain:  
			aurora_forwarding_bufferbase_reg : out std_logic_vector(31 downto 0); 
			aurora_forwarding_bufsize_reg  : out std_logic_vector(31 downto 0);
			aurora_local_id : out  std_logic_vector(15 downto 0); 
			--data to host:
			aurora_forwreq_pointer_regdin : in  std_logic_vector(31 downto 0); 
			aurora_forwreq_pointer_regwr_en : in  std_logic; 
			aurora_forwreq_pointer_regfull : out std_logic; 
			aurora_rdcompl_localaddress_regdin : in  std_logic_vector(31 downto 0); 
			aurora_rdcompl_localaddress_regwr_en : in  std_logic; 
			aurora_rdcompl_localaddress_regfull : out std_logic; 
			aurora_arrivedwrite_address_regdin : in  std_logic_vector(31 downto 0); 
			aurora_arrivedwrite_address_regwr_en : in  std_logic; 
			aurora_arrivedwrite_address_regfull : out std_logic
			  );
end op2p_host_wb_if;

architecture Behavioral of op2p_host_wb_if is

   -- Internal Signals ------------------------------------------------------------

  --received packet properties
  SIGNAL aurora_rx_sourceaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_targetaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_sourceid_reg  : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_targetid_reg  : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rx_targetid_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_bytecount_reg  : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_sourceaddress_regrd_en : std_logic;
  SIGNAL aurora_rx_sourceaddress_regdout : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_sourceaddress_regempty : std_logic;
  SIGNAL aurora_rx_sourceaddress_regunderflow : std_logic;
  
  --write request properties
  --SIGNAL aurora_wr_targetaddress_regrd_en : std_logic;
  --SIGNAL aurora_wr_targetaddress_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_wr_targetaddress_regempty : std_logic;
  SIGNAL aurora_wr_targetaddress_regunderflow : std_logic;
  --SIGNAL aurora_wr_sourceid_regrd_en : std_logic;
  --SIGNAL aurora_wr_sourceid_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_wr_sourceid_regempty : std_logic;
  SIGNAL aurora_wr_sourceid_regunderflow : std_logic;
  --SIGNAL aurora_wr_targetid_regrd_en : std_logic;
  --SIGNAL aurora_wr_targetid_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_wr_targetid_regempty : std_logic;
  SIGNAL aurora_wr_targetid_regunderflow : std_logic;
  --SIGNAL aurora_wr_bytecount_regrd_en : std_logic;
  --SIGNAL aurora_wr_bytecount_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_wr_bytecount_regempty : std_logic;
  SIGNAL aurora_wr_bytecount_regunderflow : std_logic;
  SIGNAL aurora_wr_sourceaddress_regfull : std_logic;
  SIGNAL aurora_wr_sourceaddress_regoverflow : std_logic;
  SIGNAL aurora_wr_targetaddress_regfull : std_logic;
  SIGNAL aurora_wr_targetaddress_regoverflow : std_logic;
  SIGNAL aurora_wr_sourceid_regfull : std_logic;
  SIGNAL aurora_wr_sourceid_regoverflow : std_logic;
  SIGNAL aurora_wr_targetid_regfull : std_logic;
  SIGNAL aurora_wr_targetid_regoverflow : std_logic;
  SIGNAL aurora_wr_bytecount_regfull : std_logic;
  SIGNAL aurora_wr_bytecount_regoverflow : std_logic;
  SIGNAL aurora_wr_sourceaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_wr_targetaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_wr_sourceid_reg  : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_wr_targetid_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_wr_bytecount_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_wr_targetaddress_regwr_en : std_logic;
  SIGNAL aurora_wr_sourceaddress_regwr_en : std_logic;
  SIGNAL aurora_wr_bytecount_regwr_en : std_logic;
  SIGNAL aurora_wr_targetid_regwr_en : std_logic;
  SIGNAL aurora_wr_sourceid_regwr_en : std_logic;

  --read request properties
  SIGNAL aurora_rdreq_localaddress_regfull : std_logic;
  SIGNAL aurora_rdreq_localaddress_regoverflow : std_logic;
  SIGNAL aurora_rdreq_targetaddress_regfull : std_logic;
  SIGNAL aurora_rdreq_targetaddress_regoverflow : std_logic;
  SIGNAL aurora_rdreq_localid_regfull : std_logic;
  SIGNAL aurora_rdreq_localid_regoverflow : std_logic;
  SIGNAL aurora_rdreq_targetid_regfull : std_logic;
  SIGNAL aurora_rdreq_targetid_regoverflow : std_logic;
  SIGNAL aurora_rdreq_bytecount_regfull : std_logic;
  SIGNAL aurora_rdreq_bytecount_regoverflow : std_logic;
  --SIGNAL aurora_rdreq_localaddress_regrd_en : std_logic;
  --SIGNAL aurora_rdreq_localaddress_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdreq_localaddress_regempty : std_logic;
  SIGNAL aurora_rdreq_localaddress_regunderflow : std_logic;
  --SIGNAL aurora_rdreq_targetaddress_regrd_en : std_logic;
  --SIGNAL aurora_rdreq_targetaddress_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdreq_targetaddress_regempty : std_logic;
  SIGNAL aurora_rdreq_targetaddress_regunderflow : std_logic;
  --SIGNAL aurora_rdreq_localid_regrd_en : std_logic;
  --SIGNAL aurora_rdreq_localid_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdreq_localid_regempty : std_logic;
  SIGNAL aurora_rdreq_localid_regunderflow : std_logic;
  --SIGNAL aurora_rdreq_targetid_regrd_en : std_logic;
  --SIGNAL aurora_rdreq_targetid_regdout : std_logic;
  --SIGNAL aurora_rdreq_targetid_regempty : std_logic;
  SIGNAL aurora_rdreq_targetid_regunderflow : std_logic;
  --SIGNAL aurora_rdreq_bytecount_regrd_en : std_logic;
  --SIGNAL aurora_rdreq_bytecount_regdout : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdreq_bytecount_regempty : std_logic;
  SIGNAL aurora_rdreq_bytecount_regunderflow : std_logic;

  --forwarding request fifo signals
  --SIGNAL aurora_forwreq_pointer_regdin : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_forwreq_pointer_regwr_en : std_logic;
  SIGNAL aurora_forwreq_pointer_regrd_en : std_logic;
  SIGNAL aurora_forwreq_pointer_reg : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_forwreq_pointer_regfull : std_logic;
  SIGNAL aurora_forwreq_pointer_regoverflow : std_logic;
  SIGNAL aurora_forwreq_pointer_regempty : std_logic;
  SIGNAL aurora_forwreq_pointer_regunderflow : std_logic;
  SIGNAL aurora_forw_freeupaddr_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_forw_freeupaddr_regwr_en : std_logic;
  --SIGNAL aurora_forw_freeupaddr_regrd_en : std_logic;
  --SIGNAL aurora_forw_freeupaddr_regdout : std_logic;
  SIGNAL aurora_forw_freeupaddr_regfull : std_logic;
  SIGNAL aurora_forw_freeupaddr_regoverflow : std_logic;
  --SIGNAL aurora_forw_freeupaddr_regempty : std_logic;
  SIGNAL aurora_forw_freeupaddr_regunderflow : std_logic;
  SIGNAL aurora_forw_freeupsize_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_forw_freeupsize_regwr_en : std_logic;
  --SIGNAL aurora_forw_freeupsize_regrd_en : std_logic;
  --SIGNAL aurora_forw_freeupsize_regdout : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_forw_freeupsize_regfull : std_logic;
  SIGNAL aurora_forw_freeupsize_regoverflow : std_logic;
  --SIGNAL aurora_forw_freeupsize_regempty : std_logic;
  SIGNAL aurora_forw_freeupsize_regunderflow   : std_logic;

  --read completion fifo signals
  --SIGNAL aurora_rdcompl_localaddress_regdin : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdcompl_localaddress_regwr_en : std_logic;
  SIGNAL aurora_rdcompl_localaddress_regrd_en : std_logic;
  SIGNAL aurora_rdcompl_localaddress_reg : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_rdcompl_localaddress_regfull : std_logic;
  SIGNAL aurora_rdcompl_localaddress_regoverflow : std_logic;
  SIGNAL aurora_rdcompl_localaddress_regempty : std_logic;
  SIGNAL aurora_rdcompl_localaddress_regunderflow : std_logic;
   
  --arrived write address fifo's signals
  --SIGNAL aurora_arrivedwrite_address_regdin : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_arrivedwrite_address_regwr_en : std_logic;
  SIGNAL aurora_arrivedwrite_address_regrd_en : std_logic;
  SIGNAL aurora_arrivedwrite_address_reg : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_arrivedwrite_address_regfull : std_logic;
  SIGNAL aurora_arrivedwrite_address_regoverflow : std_logic;
  SIGNAL aurora_arrivedwrite_address_regempty : std_logic;
  SIGNAL aurora_arrivedwrite_address_regunderflow : std_logic;

  --SIGNAL aurora_forwarding_bufferbase_reg : std_logic_VECTOR(31 downto 0);
  --SIGNAL aurora_forwarding_bufsize_reg  : std_logic_VECTOR(31 downto 0);
  
  SIGNAL aurora_fifostatus_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_local_id_copy : std_logic_VECTOR(15 downto 0);

  SIGNAL aurora_rdreq_localaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rdreq_localaddress_regwr_en : std_logic;
  SIGNAL aurora_rx_localaddress_regrd_en : std_logic;
  SIGNAL aurora_rx_localaddress_regdout : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rx_localaddress_regempty : std_logic;
  SIGNAL aurora_rx_localaddress_regunderflow : std_logic;
  SIGNAL aurora_rdreq_targetaddress_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rdreq_targetaddress_regwr_en : std_logic;
  SIGNAL aurora_rdreq_localid_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rdreq_localid_regwr_en : std_logic;
  SIGNAL aurora_rdreq_targetid_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rdreq_targetid_regwr_en : std_logic;
  SIGNAL aurora_rdreq_bytecount_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_rdreq_bytecount_regwr_en : std_logic;
  SIGNAL aurora_fifoflags_reg : std_logic_VECTOR(31 downto 0);
  SIGNAL aurora_tx_sourceaddress_regfull : std_logic;
  SIGNAL aurora_tx_sourceaddress_regoverflow : std_logic;
  SIGNAL aurora_tx_targetaddress_regfull : std_logic;
  SIGNAL aurora_tx_targetaddress_regoverflow : std_logic;
  SIGNAL aurora_tx_sourceid_regfull : std_logic;
  SIGNAL aurora_tx_sourceid_regoverflow : std_logic;
  SIGNAL aurora_tx_targetid_regfull : std_logic;
  SIGNAL aurora_tx_targetid_regoverflow : std_logic;
  SIGNAL aurora_tx_bytecount_regfull : std_logic;
  SIGNAL aurora_tx_bytecount_regoverflow : std_logic;
  SIGNAL aurora_config_state : std_logic_VECTOR(7 downto 0);
  SIGNAL aurora_config_wb_ack_o_copy : std_logic;
  SIGNAL aurora_fifostatus_regrd_en : std_logic;
  SIGNAL aurora_config_wb_addr_i8bit: std_logic_VECTOR(7 downto 0);
	
-- -----MODULE DECLARATIONs -------------------------------------------------------
	component fifo_generator_v6_1
		port (
		rst: IN std_logic;
		wr_clk: IN std_logic;
		rd_clk: IN std_logic;
		din: IN std_logic_VECTOR(31 downto 0);
		wr_en: IN std_logic;
		rd_en: IN std_logic;
		dout: OUT std_logic_VECTOR(31 downto 0);
		full: OUT std_logic;
		overflow: OUT std_logic;
		empty: OUT std_logic;
		underflow: OUT std_logic);
	end component;


-- ---------- ARCHITECTURE BEGINS -------------------------------------------------
begin

-----------------------------------------------------------------------------------
	-- COMPONENT INSTALLATIONS (connecting the IPs to local signals) ---------------

	-- ////////////// HOST INTERFACE FIFOs \\\\\\\\\\\\\\----------------
		--  Registers (aurora_config_wb bus):
		--   WRITE REQ (local host writes): source address (local), target address, source ID, target ID, 
		--    byte-count.
		--   READ REQ (local host writes): destination address (local), target source address, local ID, target ID, 
		--    byte-count.
		--   READ completion status: completed_localaddress
		--   Forwarding REQUEST received: buffer start address pointer and buffer size (local host writes it, not a FIFO), Packet 
		--     pointer (FIFO, the aurora IP writes it). The complete packet with header is stored in memory. the packet size is in the header
		--     Forwarding buffer freeup: free up buffer area already forwarded. address and size.
		--   Control registers: FIFO status for every FIFO.
		--   All of these registers are FIFOs, one transaction involves reading or writing 4 FIFOs. Source ID is local ID 
		--    for most of the transactions, except for the forwarded packets.
	--FIFO for aurora_forwreq_pointer_reg (forwarding request packet pointer)
	fifo_aurora_forwreq_pointer_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => user_clk_i,
				rd_clk => aurora_config_wb_clk_i,
				din => aurora_forwreq_pointer_regdin,
				wr_en => aurora_forwreq_pointer_regwr_en,
				rd_en => aurora_forwreq_pointer_regrd_en,
				dout => aurora_forwreq_pointer_reg,
				full => aurora_forwreq_pointer_regfull,
				overflow => aurora_forwreq_pointer_regoverflow,
				empty => aurora_forwreq_pointer_regempty,
				underflow => aurora_forwreq_pointer_regunderflow);
	--FIFO for aurora_rdcompl_localaddress_reg (read completion)
	fifo_aurora_rdcompl_localaddress_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => user_clk_i,
				rd_clk => aurora_config_wb_clk_i,
				din => aurora_rdcompl_localaddress_regdin,
				wr_en => aurora_rdcompl_localaddress_regwr_en,
				rd_en => aurora_rdcompl_localaddress_regrd_en,
				dout => aurora_rdcompl_localaddress_reg,
				full => aurora_rdcompl_localaddress_regfull,
				overflow => aurora_rdcompl_localaddress_regoverflow,
				empty => aurora_rdcompl_localaddress_regempty,
				underflow => aurora_rdcompl_localaddress_regunderflow);
	--FIFO for aurora_arrivedwrite_address_reg (arrived write's address)
	fifo_aurora_arrivedwrite_address_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => user_clk_i,
				rd_clk => aurora_config_wb_clk_i,
				din => aurora_arrivedwrite_address_regdin,
				wr_en => aurora_arrivedwrite_address_regwr_en,
				rd_en => aurora_arrivedwrite_address_regrd_en,
				dout => aurora_arrivedwrite_address_reg,
				full => aurora_arrivedwrite_address_regfull,
				overflow => aurora_arrivedwrite_address_regoverflow,
				empty => aurora_arrivedwrite_address_regempty,
				underflow => aurora_arrivedwrite_address_regunderflow);
	--FIFO for aurora_wr_sourceaddress_reg (write request)
	fifo_aurora_wr_sourceaddress_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_wr_sourceaddress_reg,
				wr_en => aurora_wr_sourceaddress_regwr_en,
				rd_en => aurora_rx_sourceaddress_regrd_en,
				dout => aurora_rx_sourceaddress_regdout,
				full => aurora_wr_sourceaddress_regfull,
				overflow => aurora_wr_sourceaddress_regoverflow,
				empty => aurora_rx_sourceaddress_regempty,
				underflow => aurora_rx_sourceaddress_regunderflow);
	--FIFO for aurora_wr_targetaddress_reg (write request)
	fifo_aurora_wr_targetaddress_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_wr_targetaddress_reg,
				wr_en => aurora_wr_targetaddress_regwr_en,
				rd_en => aurora_wr_targetaddress_regrd_en,
				dout => aurora_wr_targetaddress_regdout,
				full => aurora_wr_targetaddress_regfull,
				overflow => aurora_wr_targetaddress_regoverflow,
				empty => aurora_wr_targetaddress_regempty,
				underflow => aurora_wr_targetaddress_regunderflow);
	--FIFO for aurora_wr_sourceid_reg (write request)
	fifo_aurora_wr_sourceid_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_wr_sourceid_reg,
				wr_en => aurora_wr_sourceid_regwr_en,
				rd_en => aurora_wr_sourceid_regrd_en,
				dout => aurora_wr_sourceid_regdout,
				full => aurora_wr_sourceid_regfull,
				overflow => aurora_wr_sourceid_regoverflow,
				empty => aurora_wr_sourceid_regempty,
				underflow => aurora_wr_sourceid_regunderflow);
	--FIFO for aurora_wr_targetid_reg (write request)
	fifo_aurora_wr_targetid_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_wr_targetid_reg,
				wr_en => aurora_wr_targetid_regwr_en,
				rd_en => aurora_wr_targetid_regrd_en,
				dout => aurora_wr_targetid_regdout,
				full => aurora_wr_targetid_regfull,
				overflow => aurora_wr_targetid_regoverflow,
				empty => aurora_wr_targetid_regempty,
				underflow => aurora_wr_targetid_regunderflow);
	--FIFO for aurora_wr_bytecount_reg (write request)
	fifo_aurora_wr_bytecount_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_wr_bytecount_reg,
				wr_en => aurora_wr_bytecount_regwr_en,
				rd_en => aurora_wr_bytecount_regrd_en,
				dout => aurora_wr_bytecount_regdout,
				full => aurora_wr_bytecount_regfull,
				overflow => aurora_wr_bytecount_regoverflow,
				empty => aurora_wr_bytecount_regempty,
				underflow => aurora_wr_bytecount_regunderflow);
	--FIFO for aurora_rdreq_localaddress_reg (read request)
	fifo_aurora_rdreq_localaddress_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_rdreq_localaddress_reg,
				wr_en => aurora_rdreq_localaddress_regwr_en,
				rd_en => aurora_rx_localaddress_regrd_en,
				dout => aurora_rx_localaddress_regdout,
				full => aurora_rdreq_localaddress_regfull,
				overflow => aurora_rdreq_localaddress_regoverflow,
				empty => aurora_rx_localaddress_regempty,
				underflow => aurora_rx_localaddress_regunderflow);
	--FIFO for aurora_rdreq_targetaddress_reg (read request)
	fifo_aurora_rdreq_targetaddress_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_rdreq_targetaddress_reg,
				wr_en => aurora_rdreq_targetaddress_regwr_en,
				rd_en => aurora_rdreq_targetaddress_regrd_en,
				dout => aurora_rdreq_targetaddress_regdout,
				full => aurora_rdreq_targetaddress_regfull,
				overflow => aurora_rdreq_targetaddress_regoverflow,
				empty => aurora_rdreq_targetaddress_regempty,
				underflow => aurora_rdreq_targetaddress_regunderflow);
	--FIFO for aurora_rdreq_localid_reg (read request)
	fifo_aurora_rdreq_localid_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_rdreq_localid_reg,
				wr_en => aurora_rdreq_localid_regwr_en,
				rd_en => aurora_rdreq_localid_regrd_en,
				dout => aurora_rdreq_localid_regdout,
				full => aurora_rdreq_localid_regfull,
				overflow => aurora_rdreq_localid_regoverflow,
				empty => aurora_rdreq_localid_regempty,
				underflow => aurora_rdreq_localid_regunderflow);
	--FIFO for aurora_rdreq_targetid_reg (read request)
	fifo_aurora_rdreq_targetid_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_rdreq_targetid_reg,
				wr_en => aurora_rdreq_targetid_regwr_en,
				rd_en => aurora_rdreq_targetid_regrd_en,
				dout => aurora_rdreq_targetid_regdout,
				full => aurora_rdreq_targetid_regfull,
				overflow => aurora_rdreq_targetid_regoverflow,
				empty => aurora_rdreq_targetid_regempty,
				underflow => aurora_rdreq_targetid_regunderflow);
	--FIFO for aurora_rdreq_bytecount_reg (read request)
	fifo_aurora_rdreq_bytecount_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_rdreq_bytecount_reg,
				wr_en => aurora_rdreq_bytecount_regwr_en,
				rd_en => aurora_rdreq_bytecount_regrd_en,
				dout => aurora_rdreq_bytecount_regdout,
				full => aurora_rdreq_bytecount_regfull,
				overflow => aurora_rdreq_bytecount_regoverflow,
				empty => aurora_rdreq_bytecount_regempty,
				underflow => aurora_rdreq_bytecount_regunderflow);
	--FIFO for aurora_forw_freeupaddr_reg (forwarding buffer freeup)
	fifo_aurora_forw_freeupaddr_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_forw_freeupaddr_reg,
				wr_en => aurora_forw_freeupaddr_regwr_en,
				rd_en => aurora_forw_freeupaddr_regrd_en,
				dout => aurora_forw_freeupaddr_regdout,
				full => aurora_forw_freeupaddr_regfull,
				overflow => aurora_forw_freeupaddr_regoverflow,
				empty => aurora_forw_freeupaddr_regempty,
				underflow => aurora_forw_freeupaddr_regunderflow);
	--FIFO for aurora_forw_freeupsize_reg (forwarding buffer freeup)
	fifo_aurora_forw_freeupsize_reg : fifo_generator_v6_1
			port map (
				rst => aurora_reset,
				wr_clk => aurora_config_wb_clk_i,
				rd_clk => user_clk_i,
				din => aurora_forw_freeupsize_reg,
				wr_en => aurora_forw_freeupsize_regwr_en,
				rd_en => aurora_forw_freeupsize_regrd_en,
				dout => aurora_forw_freeupsize_regdout,
				full => aurora_forw_freeupsize_regfull,
				overflow => aurora_forw_freeupsize_regoverflow,
				empty => aurora_forw_freeupsize_regempty,
				underflow => aurora_forw_freeupsize_regunderflow);


 -- --------- MAIN LOGIC ----------------------------------------------------------
 
 aurora_config_wb_addr_i8bit(4 downto 0) <= aurora_config_wb_addr_i;
 aurora_config_wb_addr_i8bit(7 downto 5) <= "000";
 
 
 -- FIFO FLAGS REGISTER:
----fifo flags of write req
aurora_fifoflags_reg (0) <= aurora_tx_sourceaddress_regfull;
aurora_fifoflags_reg (1) <= aurora_tx_sourceaddress_regoverflow;
aurora_fifoflags_reg (2) <= aurora_tx_targetaddress_regfull;
aurora_fifoflags_reg (3) <= aurora_tx_targetaddress_regoverflow;
aurora_fifoflags_reg (4) <= aurora_tx_sourceid_regfull;
aurora_fifoflags_reg (5) <= aurora_tx_sourceid_regoverflow;
aurora_fifoflags_reg (6) <= aurora_tx_targetid_regfull;
aurora_fifoflags_reg (7) <= aurora_tx_targetid_regoverflow;
aurora_fifoflags_reg (8) <= aurora_tx_bytecount_regfull;
aurora_fifoflags_reg (9) <= aurora_tx_bytecount_regoverflow;
----fifo flags of read req
aurora_fifoflags_reg (10) <= aurora_rdreq_localaddress_regfull;
aurora_fifoflags_reg (11) <= aurora_rdreq_localaddress_regoverflow;
aurora_fifoflags_reg (12) <= aurora_rdreq_targetaddress_regfull;
aurora_fifoflags_reg (13) <= aurora_rdreq_targetaddress_regoverflow;
aurora_fifoflags_reg (14) <= aurora_rdreq_localid_regfull;
aurora_fifoflags_reg (15) <= aurora_rdreq_localid_regoverflow;
aurora_fifoflags_reg (16) <= aurora_rdreq_targetid_regfull;
aurora_fifoflags_reg (17) <= aurora_rdreq_targetid_regoverflow;
aurora_fifoflags_reg (18) <= aurora_rdreq_bytecount_regfull;
aurora_fifoflags_reg (19) <= aurora_rdreq_bytecount_regoverflow;
--forwarding freeup. write here:
aurora_fifoflags_reg (20) <= aurora_forw_freeupaddr_regfull;
aurora_fifoflags_reg (21) <= aurora_forw_freeupaddr_regoverflow;
aurora_fifoflags_reg (22) <= aurora_forw_freeupsize_regfull;
aurora_fifoflags_reg (23) <= aurora_forw_freeupsize_regoverflow;
-----registers to read here:
aurora_fifoflags_reg (24) <= aurora_forwreq_pointer_regempty;
aurora_fifoflags_reg (25) <= aurora_forwreq_pointer_regunderflow;
aurora_fifoflags_reg (26) <= aurora_rdcompl_localaddress_regempty;
aurora_fifoflags_reg (27) <= aurora_rdcompl_localaddress_regunderflow;
aurora_fifoflags_reg (28) <= aurora_arrivedwrite_address_regempty;
aurora_fifoflags_reg (29) <= aurora_arrivedwrite_address_regunderflow;
aurora_fifoflags_reg (31 downto 30) <= (OTHERS => '0');



	-- WISHBONE SLAVE INTERFACE ----------------------------------------------------
	--this is for control and configuration by the local host/cpu
	--  Registers (aurora_config_wb bus):
	--   TX (local host writes): source address (local), target address, source ID (set up once), target ID, 
	--    byte-count.
	--   RX (this IP writes it): source address (remote), target address (local), source ID, target ID 
	--    (check for match or forwarding), byte-count.
	--   Forwarding: buffer start address pointer and buffer size (local host writes it), Packet 
	--     pointer (FIFO, the aurora IP writes it). The complete packet with header is stored in memory.
	--   Control registers: FIFO status for every FIFO.
	--   All of these registers are FIFOs, one transaction involves reading or writing 4 FIFOs.
	-- The local host has to check if the FIFO-full flags are '0', otherwise an overwrite will occur.
	--  Instead of holding the wb_ack antil it gets empty, we let it overwrite. This was we can
	--  prevent system hang on the wishbone bus.
	--Register Addresses:
	---------------------
	--00h - aurora_fifostatus_reg 
	--01h - aurora_wr_sourceaddress_reg
	--02h - aurora_wr_targetaddress_reg
	--03h - aurora_wr_sourceid_reg 
	--04h - aurora_wr_targetid_reg
	--05h - aurora_wr_bytecount_reg
	--06h - aurora_rdreq_localaddress_reg
	--07h - aurora_rdreq_targetaddress_reg
	--08h - aurora_rdreq_localid_reg
	--09h - aurora_rdreq_targetid_reg
	--0ah - aurora_rdreq_bytecount_reg
	--0bh - aurora_rdcompl_localaddress_reg 
	--0ch - aurora_forwarding_bufferbase_reg
	--0dh - aurora_forwarding_bufsize_reg 
	--0eh - aurora_forw_freeupaddr_reg
	--0fh - aurora_forw_freeupsize_reg
	--10h - aurora_forwreq_pointer_reg
	--11h - aurora_arrivedwrite_address_reg
	--12h - aurora_local_id
	
				--the wishbone slave state machine---------------------
				wishbone: process (aurora_reset, aurora_config_wb_wr_i, aurora_config_wb_clk_i, aurora_local_id_copy,
										aurora_config_wb_cyc_i, aurora_config_wb_addr_i, aurora_config_wb_data_o) is
					begin
					if (aurora_reset='1') then 
					  aurora_config_wb_data_i(31 downto 0) <= (others => '0'); 
					  aurora_wr_sourceaddress_reg <= (OTHERS => '0');
					  aurora_wr_targetaddress_reg <= (OTHERS => '0');
					  aurora_wr_sourceid_reg <= (OTHERS => '0'); 
					  aurora_wr_targetid_reg <= (OTHERS => '0');
					  aurora_wr_bytecount_reg <= (OTHERS => '0');
					  aurora_forwarding_bufferbase_reg <= (OTHERS => '0');
					  aurora_forwarding_bufsize_reg  <= (OTHERS => '0');
					  aurora_fifostatus_reg  <= (OTHERS => '0');
					  aurora_rdreq_localaddress_reg <= (OTHERS => '0');
					  aurora_rdreq_targetaddress_reg <= (OTHERS => '0');
					  aurora_rdreq_localid_reg <= (OTHERS => '0');
					  aurora_rdreq_targetid_reg <= (OTHERS => '0');
					  aurora_rdreq_bytecount_reg <= (OTHERS => '0');
					  aurora_forw_freeupaddr_reg <= (OTHERS => '0');
					  aurora_forw_freeupsize_reg <= (OTHERS => '0');
						aurora_wr_targetaddress_regwr_en  <= '0';
						aurora_wr_sourceaddress_regwr_en  <= '0';
						aurora_wr_bytecount_regwr_en  <= '0';
						aurora_wr_targetid_regwr_en  <= '0';
						aurora_wr_sourceid_regwr_en  <= '0';
						aurora_rdreq_localaddress_regwr_en <= '0';
						aurora_rdreq_targetaddress_regwr_en <= '0';
						aurora_rdreq_localid_regwr_en <= '0';
						aurora_rdreq_targetid_regwr_en <= '0';
						aurora_rdreq_bytecount_regwr_en <= '0';
						aurora_forw_freeupaddr_regwr_en <= '0';
						aurora_forw_freeupsize_regwr_en <= '0';
						aurora_forwreq_pointer_regrd_en <= '0';
						aurora_rdcompl_localaddress_regrd_en <= '0';
						aurora_arrivedwrite_address_regrd_en <= '0';
						aurora_config_state <= (OTHERS => '0');
						aurora_config_wb_ack_o <= '0';
						aurora_config_wb_ack_o_copy <= '0';
						aurora_local_id <= (OTHERS => '0');
					else
						if (aurora_config_wb_clk_i'event and aurora_config_wb_clk_i = '1') then
						
							 case ( aurora_config_state ) is

							 --********** IDLE STATE  **********
							 when "00000000" =>   --state 0    
								aurora_config_wb_ack_o <= '0';	
								aurora_wr_targetaddress_regwr_en  <= '0';
								aurora_wr_sourceaddress_regwr_en  <= '0';
								aurora_wr_bytecount_regwr_en  <= '0';
								aurora_wr_targetid_regwr_en  <= '0';
								aurora_wr_sourceid_regwr_en  <= '0';
								aurora_rdreq_localaddress_regwr_en <= '0';
								aurora_rdreq_targetaddress_regwr_en <= '0';
								aurora_rdreq_localid_regwr_en <= '0';
								aurora_rdreq_targetid_regwr_en <= '0';
								aurora_rdreq_bytecount_regwr_en <= '0';
								aurora_forw_freeupaddr_regwr_en <= '0';
								aurora_forw_freeupsize_regwr_en <= '0';
								aurora_forwreq_pointer_regrd_en <= '0';
								aurora_rdcompl_localaddress_regrd_en <= '0';	
								aurora_arrivedwrite_address_regrd_en <= '0';								
								--writes:
								if (aurora_config_wb_cyc_i = '1' and aurora_config_wb_wr_i = '1' and aurora_config_wb_ack_o_copy='0') then 
									aurora_config_state <= "00000001";
								--reads:
								elsif (aurora_config_wb_cyc_i = '1' and aurora_config_wb_wr_i = '0' and aurora_config_wb_ack_o_copy='0')	then --read
									aurora_config_state <= "00000010";
								end if;

							 --********** write STATE ********** 
							 when "00000001" =>   --state 1
								  aurora_config_state <= "00000000"; --no wait states, go back to idle
								  aurora_config_wb_ack_o <= '1';
								  aurora_config_wb_ack_o_copy <= '1';
								if (  aurora_config_wb_addr_i8bit(7 downto 0) = X"01" ) then 
								  aurora_wr_sourceaddress_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_wr_sourceaddress_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"02" ) then 
								  aurora_wr_targetaddress_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_wr_targetaddress_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"03" ) then 
								  aurora_wr_sourceid_reg <=   aurora_config_wb_data_o(31 downto 0); 
								  aurora_wr_sourceid_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"04" ) then 
								  aurora_wr_targetid_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_wr_targetid_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"05" ) then 
								  aurora_wr_bytecount_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_wr_bytecount_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"06" ) then 
								  aurora_rdreq_localaddress_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_rdreq_localaddress_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"07" ) then 
								  aurora_rdreq_targetaddress_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_rdreq_targetaddress_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"08" ) then 
								  aurora_rdreq_localid_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_rdreq_localid_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"09" ) then 
								  aurora_rdreq_targetid_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_rdreq_targetid_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"0a" ) then 
								  aurora_rdreq_bytecount_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_rdreq_bytecount_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"0c" ) then 
								  aurora_forwarding_bufferbase_reg <=   aurora_config_wb_data_o(31 downto 0);
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"0d" ) then 
								  aurora_forwarding_bufsize_reg <=   aurora_config_wb_data_o(31 downto 0); 
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"0e" ) then 
								  aurora_forw_freeupaddr_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_forw_freeupaddr_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"0f" ) then 
								  aurora_forw_freeupsize_reg <=   aurora_config_wb_data_o(31 downto 0);
								  aurora_forw_freeupsize_regwr_en  <= '1';
								elsif (  aurora_config_wb_addr_i8bit(7 downto 0) = X"12" ) then 
								  aurora_local_id <=   aurora_config_wb_data_o(15 downto 0);
								  aurora_local_id_copy <=   aurora_config_wb_data_o(15 downto 0);
								end if; 

							 --********** read STATE **********     				 
							 when "00000010" =>   --state 2
								  aurora_config_state <= "00000000"; --no wait states, go back to idle
								  aurora_config_wb_ack_o <= '1';
								  aurora_config_wb_ack_o_copy <= '1';
								if (aurora_config_wb_addr_i8bit(7 downto 0) = X"00" ) then 
								  aurora_config_wb_data_i(31 downto 0) <= aurora_fifostatus_reg; 
								  aurora_fifostatus_regrd_en <='1';
								elsif (aurora_config_wb_addr_i8bit(7 downto 0) = X"0b" ) then 
								  aurora_config_wb_data_i(31 downto 0) <= aurora_rdcompl_localaddress_reg; 
								  aurora_rdcompl_localaddress_regrd_en <='1';
								elsif (aurora_config_wb_addr_i8bit(7 downto 0) = X"10" ) then 
								  aurora_config_wb_data_i(31 downto 0) <= aurora_forwreq_pointer_reg;
								  aurora_forwreq_pointer_regrd_en <='1';
								elsif (aurora_config_wb_addr_i8bit(7 downto 0) = X"11" ) then 
								  aurora_config_wb_data_i(31 downto 0) <= aurora_arrivedwrite_address_reg;
								  aurora_arrivedwrite_address_regrd_en <='1';
								elsif (aurora_config_wb_addr_i8bit(7 downto 0) = X"12" ) then 
								  aurora_config_wb_data_i(15 downto 0) <= aurora_local_id_copy;
								end if;
									
							 when others => --error
									 aurora_config_state <= "00000000"; --go to state 0
							 end case; 

						end if;
					end if;
				end process wishbone;	
				
				--  Interrupts to local host:
				--   - read completion (fifo was written)
				--   - forwarding request
				--   - write arrived
				aurora_irq <= (not aurora_forwreq_pointer_regempty)
					or (not aurora_rdcompl_localaddress_regempty)
					or (not aurora_arrivedwrite_address_regempty);
				--flag: if any of the readable FIFOs is not empty, the interrupt is asserted.








-------------- END FILE -----------------------------------------------------------
end Behavioral;

